'--------------------------------------------------------------
'Ansteuereungsbeispiele fr IC-Bus-Multitreiber "int_i2c.s19"
'CCTools 2004 cctools.hs-control.de (23.08.2004)
'--------------------------------------------------------------
' Ansteuerung von IC-Bus Bausteine:
' - PCF8574 / PCF8574A
' - PCFLCD-Interface / I2C-Terminal
' - Bausteine mit Byte-Adressregister
'    z.B. PCF8583, PCF8591, DS1631, MAX520, MAX7311, MAX4572 etc.
' - Bausteine mit Word-Adressregister
'    z.B. EEProms 24C32 bis 24C512
'--------------------------------------------------------------

'--------------------------------------------------------------
'Einsprungadressen von "int_i2c.s19" Release 19.09.04
'--------------------------------------------------------------
' PCF8574:
define PCFwrite   &h101
define PCFread    &h107
'--------------------------------------------------------------
' Bausteine mit Byte-Adress-Register
define WrByteBReg &h123
define WrWordBReg &h12F
define RdByteBReg &h15C
define RdWordBReg &h162
'--------------------------------------------------------------
' Bausteine mit Word-Adress-Register
define WrByteWReg &h139
define WrWordWReg &h141
define RdByteWReg &h16D
define RdWordWReg &h175
'--------------------------------------------------------------
' PCFLCD:
define putCmd8Bit &h1a9
define putCmd     &h17D
define putChar    &h1a3
define prnLCD     &h1C2
'--------------------------------------------------------------

'LCD-ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E   : Define GRAD &hDF
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD

define PCF 64 'Adresse des PCF-LCDs. Alternativ kann auch eine Varible benutzt werden.

define pop DA[1] 'Trick zum Auslesen des Stacks(siehe ccintern.dharlos.de)

define LCDLight Bit[192] 'Zustandsbit fr die LCD-Beleuchtung
define cmd Byte[2] ' Byte zur Parameterbergabe

define wert Byte[1]
define P0 Bit[1]   ' Portzustnde. Es kann jedes
define P1 Bit[2]   ' beliebige Byte vom RAM gewhlt
define P2 Bit[3]   ' werden.
define P3 Bit[4]
define P4 Bit[5]
define P5 Bit[6]
define P6 Bit[7]
define P7 Bit[8]

define Wordwert word[2]
define MSB byte[3]
define LSB byte[4]
define data word[4]
define addr word[3]
define i2caddr byte[7]

'goto DS1631 'Testroutine fr DS1631
'goto MAX520 'Testroutine fr MAX520


'----PCF8574-Aufrufe-------------------------
'Byte zum PCF8574 senden:
sys PCFwrite,wert,PCF
wert=wert+1

'Byte vom PCF8574 lesen:
sys PCFread,PCF+1 'Leseadresse=65
wert=pop

'Einzelport am PCF8574 setzen:
sys PCFread,PCF+1
wert=pop
P2 = off 'z.B P2 am PCF8574 auf Low setzen
sys PCFwrite,wert,PCF

'Einzelport am PCF8574 umschalten(toggle):
sys PCFread,PCF+1
wert=pop
P0 = not P0 'z.B P0 am PCF8574 togglen
sys PCFwrite,wert,PCF



'----Aufrufe-Bausteine m.Byte-Addr.Reg.----------------
'i2caddr immer Schreibadresse !!
'addr = Registeradresse
'Byte schreiben:
sys WrByteBReg,wert,addr,i2caddr

'Byte lesen:
sys RdByteBReg,addr,i2caddr
wert=pop

'Word schreiben:
sys WrWordBReg,Wordwert,addr,i2caddr

'Word lesen:
sys RdWordBReg,addr,i2caddr
Wordwert=pop



'----Aufrufe-Bausteine m.Word-Addr.Reg.----------------
'i2caddr immer Schreibadresse !!
'addr = Registeradresse
'Byte schreiben:
sys WrByteWReg,wert,addr,i2caddr

'Byte lesen:
sys RdByteWReg,addr,i2caddr
wert=pop

'Word schreiben:
sys WrWordWReg,Wordwert,addr,i2caddr

'Word lesen:
sys RdWordWReg,addr,i2caddr
Wordwert=pop


'----Spezielle Bausteine-------------------------------

'--- DS1631 ---
define DS1631addr &b10010000
#DS1631 'lauffhige Routine
sys WrByteBReg,&b1100,&hAC,DS1631addr 'Init
sys PCFwrite,&h51,DS1631addr 'Init Kommando &h51
LCDLight=On
gosub LCD_Init 'PCF-LCD initialisieren
sys prnLCD,LCDLight,0,PCF : print "CCTools (c)2004";
cmd=Line2+6 : gosub LCD_CMD
sys putChar,LCDLight,GRAD,PCF
sys putChar,LCDLight,C_,PCF

#DS1631_Loop
 sys RdWordBReg,&hAA,DS1631addr 'Sensor auslesen
 Wordwert=pop
 if MSB and &h80 then goto negnum
  data=MSB * 100
  goto endif
 #negnum
  data = (128 - (MSB and &h7F))*(-100)
 #endif
  data=(((LSB shr 4) * 25)/4)+data

 'Ausgabe ber PCFLCD:
 cmd=Line2 : gosub LCD_CMD
 Wordwert=data
 gosub LCD_Zahl5n2
 'Ausgabe ber Terminal:
 put 12
 print data/100;",";
 data=abs(data) mod 100
 print data/10;data mod 10;" C";
 pause 25
goto DS1631_Loop


'--- MAX520 ---
Define MAX520addr &h50
#MAX520 'lauffhige Routine
sys PCFwrite,&h10,MAX520addr 'Init

wert=0
data=1
#MAX520_Loop
 sys WrByteBReg,wert,1,MAX520addr ' DA-Ausgang 0 setzen
 'Ausgabe des DA-Werts ber Terminal:
 put 12
 print wert;
 if wert=255 and data=1 then data=-1
 if wert=0 and data=-1 then data=1
 wert=wert+data
 pause 10
goto MAX520_Loop



'----LCD-Funktionen-------------------------------------
'Zahlausgaben
#LCD_Zahl5n2 ' 5 stellige Festkommazahl ausgeben (##0,00)(-99,99 bis +327,67)
if Wordwert<=9999 then goto zk5s
 sys putChar,LCDLight,(Wordwert/10000)+&h30,PCF
 goto endif_z5
 #zk5s
 if Wordwert and &h8000 then goto zneg
 sys putChar,LCDLight,&h20,PCF
 goto endif_z5
 #zneg
 sys putChar,LCDLight,MINUS,PCF
 Wordwert=abs(Wordwert)
#endif_z5
if Wordwert > 999 then sys putChar,LCDLight,((Wordwert/1000) mod 10)+&h30,PCF else sys putChar,LCDLight,&h20,PCF
sys putChar,LCDLight,((Wordwert/100) mod 10)+&h30,PCF
sys putChar,LCDLight,DOT,PCF
cmd=Wordwert mod 100
goto LCD_Zahl2null

#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if cmd > 99 then sys putChar,LCDLight,(cmd/100)+&h30,PCF else sys putChar,LCDLight,&h20,PCF
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if cmd > 9 then sys putChar,LCDLight,((cmd/10) mod 10)+&h30,PCF else sys putChar,LCDLight,&h20,PCF
#LCD_Zahl1 '1 stellige Zahl ausgeben
sys putChar,LCDLight,(cmd mod 10)+&h30,PCF
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys putChar,LCDLight,(cmd/100)+&h30,PCF
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys putChar,LCDLight,((cmd/10) mod 10)+&h30,PCF
goto LCD_Zahl1

#LCD_CLS
sys putCmd,LCDLight,&b00000001,PCF
return
#LCD_CMD
sys putCmd,LCDLight,cmd,PCF
return
#LCD_Char
sys putChar,LCDLight,cmd,PCF
return
#LCD_Init
sys putCmd8Bit,LCDLight,&b00110000,PCF
sys putCmd8Bit,LCDLight,&b00110000,PCF
sys putCmd8Bit,LCDLight,&b00110000,PCF
sys putCmd8Bit,LCDLight,&b00100000,PCF
sys putCmd,LCDLight,&b00101000,PCF
sys putCmd,LCDLight,&b00001100,PCF
sys putCmd,LCDLight,&b00000001,PCF
sys putCmd,LCDLight,&b00000110,PCF
return


syscode "int_i2c.s19" 'nur einmal laden, dann auskommentieren
